
.h8300h   

; *************************
; ASM-Routine LED-Lauflicht
; Martin Hess 
; 10.9.2001 MC2 
; *************************
; Variablenuebergabe:
; Speed (long int): er0
; count (int) 		: r1
; pattern (char)	: r2l 
; *************************

	.global _ASM_Led

_ASM_Led: 
			PUSH er6		; ER6 sichern 
			PUSH er5		; ER5 sichern
			PUSH er4		; ER4 sichern 
			PUSH er3		; ER3 sichern 
			PUSH er2		; ER2 sichern
			PUSH er1		; ER1 sichern 
			PUSH er0		; ER0 sichern
			MOV.W r1,r4
         JMP Flash
         
Flash:	ROTL.B r2l
			MOV.B r2l,@0x400040
			JSR Pause
			DEC.W #1,r4
			BEQ Bye
			BRA Flash
			
Pause:	MOV.L er0,er5
Wait:		ADDX r6l,r6h 
			ADDX r6h,r6l
			ADDX r6l,r6h
			ADDX r6h,r6l
			DEC.L #1,er5
			BNE Wait
			RTS

Bye:		POP er0	; ER0 wiederherstellen
			POP er1	; ER1 wiederherstellen
			POP er2	; ER2 wiederherstellen
			POP er3	; ER3 wiederherstellen
			POP er4	; ER4 wiederherstellen
			POP er5	; ER5 wiederherstellen
			POP er6	; ER6 wiederherstellen 
			RTS
	.end     
	